diff -ur ../horde/lib/Horde/MIME/Part.php lib/Horde/MIME/Part.php
--- ../horde/lib/Horde/MIME/Part.php	2007-11-02 14:32:33.000000000 +0800
+++ lib/Horde/MIME/Part.php	2008-01-06 22:52:10.000000000 +0800
@@ -380,6 +380,11 @@
         if (strlen($contents)) {
             $this->setContents($contents, $this->_currentEncoding);
         }
+
+        /* chhsiao.080106: dirty hack for mails which specify wrong charset, especially those generated by Horde */
+        if (MIME::is_utf8($contents) && strtolower($this->getCharset()) != 'utf-8') {
+            $this->setCharset('utf-8');
+        }
     }
 
     /**
diff -ur ../horde/lib/Horde/MIME.php lib/Horde/MIME.php
--- ../horde/lib/Horde/MIME.php	2008-01-06 22:35:38.000000000 +0800
+++ lib/Horde/MIME.php	2008-01-06 22:49:46.000000000 +0800
@@ -376,13 +376,13 @@
         case 'q':
             $encoded_text = str_replace('_', ' ', $encoded_text);
             $decoded = preg_replace('/=([0-9a-f]{2})/ie', 'chr(0x\1)', $encoded_text);
-            $decoded = String::convertCharset($decoded, $charset, $to_charset);
+            $convert = true;
             break;
 
         case 'B':
         case 'b':
             $decoded = base64_decode($encoded_text);
-            $decoded = String::convertCharset($decoded, $charset, $to_charset);
+            $convert = true;
             break;
 
         default:
@@ -390,7 +390,16 @@
             break;
         }
 
-        return $preceding . $decoded . MIME::decode($rest, $to_charset);
+        $decoded .= MIME::decode($rest, $charset);
+        if($convert){
+            /* chhsiao.080106: dirty hack for mails which specify wrong charset, especially those generated by Horde */
+            if (MIME::is_utf8($decoded) && strtolower($charset) != "utf-8") {
+                $charset = 'utf-8';
+            }
+            $decoded = String::convertCharset($decoded, $charset, $to_charset);
+        }
+
+        return $preceding . $decoded;
     }
 
     /**
